//+------------------------------------------------------------------+
//|                             PriceChannel Parabolic system_v1.mq5 |
//|                                Copyright  2013, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property tester_indicator "PriceChannel_Signal"
#property tester_indicator "Color_Parabolic"
#property tester_indicator "UltraRSI"

#include <Trade\Trade.mqh>
#include <SmoothAlgorithms.mqh>

CTrade  trade;

input string               Expert_Name          = "PriceChannel Parabolic_v1";

input int                  Magic                =   121211;     // Magic Number
input int                  Slippage             =        3;     // Slippage in pips
 
input string               slInputs             = " StopLoss settings: ";
input int                  StopLossMode         =        1;     // StopLoss Mode(0-off,1-in pips)  
input double               StopLoss             =       20;     // StoplLoss in pips    

input string               tpInputs             = " TakeProfit settings: ";   
input int                  TakeProfitMode       =        0;     // TakeProfit Mode(0-off,1-in pips)  
input double               TakeProfit           =        0;     // Take Profit in pips   

input int                  ExitMode             =        0;     // Exit Mode(0-off,1-by opposite signal)

input double               TrailingStop         =        0;     // Trailing Stop in pips
input double               BreakEven            =        0;     // Breakeven in pips  
input double               ProfitLock           =        0;     // ProfitLock: StopLoss moves to entry price +/- ProfitLock pips after price reaches BreakEven level. 

input int                  ReverseMode          =        0; 
input int                  CommentMode          =        0;     // Comments Mode: 0-off,1-on(use only for Live Trading and Visual Testing) 
input int                  DebugMode            =        0;     // Debugging Mode: 0-off,1-off


input string               Time_Inputs          = "---- Timing parameters ----";
input int                  MainTimeFrame        =       -1;     // Time Frame in min(0-current,-1-each tick mode)
input int                  StartHour            =        0;     // Start Hour of Trade Session 
input int                  StartMinute          =        0;     // Start Minute of Trade Session 
input int                  EndHour              =       18;     // End Hour of Trade Session
input int                  EndMinute            =       31;     // End Minute of Trade Session
input int                  MonStartHour         =       -1;     // Monday Start Hour of Trade Session 
input int                  MonStartMinute       =        0;     // Monday Start Minute of Trade Session 
input int                  FriEndHour           =       -1;     // Friday End Hour of Trade Session
input int                  FriEndMinute         =        0;     // Friday End Minute of Trade Session
input int                  TradeDay             =       -1;     // Trade Day of Week (ex.1-Monday,-1-all Days)
input int                  NonTradeDay          =        0;     // Non-Trading Day of Week (ex.5-Friday)

input int                  CloseTimeMode        =        0;     // CloseTime mode: 0-off,1-on
input int                  CloseHour            =       23;     // Trade Close Hour   
input int                  CloseMinute          =       55;     // Trade Close Minute   
input int                  FriCloseHour         =       22;     // Trade Close Hour in Friday   
input int                  FriCloseMinute       =       55;     // Trade Close Minute in Friday 

input string               pcsInputs            = " PriceChannle Signal settings: ";
input ENUM_TIMEFRAMES      pcsTimeFrame         = PERIOD_CURRENT; // Time Frame in min(0-current)
input int                  pcsLength            =       9;        // Price channel length
input ENUM_APPLIED_PRICE   pcsPrice             = PRICE_CLOSE;    // Aplied price 
input double               pcsRisk              =       3;        // Risk in percents 
input bool                 pcsUseReEntry        =   false;        // Re-entry usage
input int                  pcsShift             =       1;        // 0-current bar,1-previous closed bar 
input int                  pcsMode              =       1;        // PriceChannel Signal Mode(0-off)

input string               sarInputs            = " Color Parabolic settings: ";
input ENUM_TIMEFRAMES      sarTimeFrame         = PERIOD_CURRENT; // Time Frame in min(0-current)
input double               sarStep              =    0.02;        // Step
input double               sarMaximum           =     0.2;        // Maximum
input int                  sarShift             =       1;        // 0-current bar,1-previous closed bar 
input int                  sarMode              =       1;        // Color Parabolic Mode(0-off)

input string               rsiInputs            = " UltraRSI settings: ";
input ENUM_TIMEFRAMES      rsiTimeFrame         = PERIOD_CURRENT; // Time Frame in min(0-current)
input int                  rsiPeriod            =      13;        // RSI indicator period
input ENUM_APPLIED_PRICE   rsiApplied_price     = PRICE_CLOSE;    // Applied price
input Smooth_Method        rsiW_Method          = MODE_JJMA;      // Smoothing method
input int                  rsiStartLength       =       3;        // Initial smoothing period                    
input int                  rsiWPhase            =     100;        // Smoothing parameter
input uint                 rsiStep              =       5;        // Period change step
input uint                 rsiStepsTotal        =      10;        // Number of period changes
input Smooth_Method        rsiSmoothMethod      = MODE_JJMA;      // Smoothing method
input int                  rsiSmoothLength      =       3;        // Smoothing depth
input int                  rsiSmoothPhase       =     100;        // Smoothing parameter    
input uint                 rsiUpLevel           =      80;        // Overbought level, %%
input uint                 rsiDnLevel           =      20;        // Oversold level, %%
input int                  rsiShift             =       1;        // 0-current bar,1-previous closed bar 
input int                  rsiMode              =       1;        // UltraRSI Mode(0-off)

input string               MM_inputs             = " MoneyManagement: ";
input int                  MM_Mode               =       0;     // MM Mode: 0-off,1-by free Margin,2-by StopLoss
input double               Lots                  =     0.1;     // Lot size
input double               RiskFactor            =       0;     // Risk Factor(in %) for MM formula 
input double               MaxLoss               =       0;     // 
input double               MaxLots               =       0;     // Max Lot Size



datetime Time[], pTime1, pTime2, prevTime, prevtime, pprevtime, upTime, dnTime;
double   dRatio, _point, minstop, contract, lot_min, lot_step, lot_max, tick_val, ProcessTime = 3;
bool     ftime, firstTime, istart;

int      handle_pcs, handle_sar, handle_rsi, Signal, Trades, over[2], upcount[2], dncount[2], maxdncount, maxupcount;
double   upSignal[], dnSignal[], upEntry[], dnEntry[], sarBuy[], sarSell[], sarUpTrend[], sarDnTrend[], rsiBulls[], rsiBears[], aLots[];
bool     timecond;

MqlTick  tick;            //
MqlTick  first_tick;      // 

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   dRatio   = MathPow(10,_Digits%2); 
   _point   = _Point*dRatio;
   minstop  = SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL)/dRatio;
   lot_min  = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
   lot_step = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_STEP);
   lot_max  = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);
   tick_val = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*dRatio;
   contract = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_CONTRACT_SIZE);   


//--- set MagicNumber for your orders identification
   trade.SetExpertMagicNumber(Magic);
//--- set available slippage in points when buying/selling
   trade.SetDeviationInPoints(Slippage*dRatio);
//--- order filling mode, the mode allowed by the server should be used
   trade.SetTypeFilling(ORDER_FILLING_RETURN);
//--- logging mode: it would be better not to declare this method at all, the class will set the best mode on its own
   trade.LogLevel(1); 
//--- what function is to be used for trading: true - OrderSendAsync(), false - OrderSend()
   trade.SetAsyncMode(false);

//----
//----   
   ArraySetAsSeries(Time,true);  
   
   if(pcsMode > 0)
   {
   handle_pcs = iCustom(Symbol(),pcsTimeFrame,"PriceChannel_Signal",pcsLength,pcsPrice,pcsRisk,pcsUseReEntry,0,0,0,0,0);
   
      if(handle_pcs == INVALID_HANDLE)
      {
      Print("Error in loading of PriceChannel_Signal. LastError = ",GetLastError());
      return(-1);
      } 
  
   ChartIndicatorAdd(ChartID(),0,handle_pcs); 
   ArraySetAsSeries(upSignal,true);  
   ArraySetAsSeries(dnSignal,true);
   ArraySetAsSeries(upEntry ,true);  
   ArraySetAsSeries(dnEntry ,true);
   }
   
   if(sarMode > 0)
   {
   handle_sar = iCustom(Symbol(),sarTimeFrame,"Color_Parabolic",sarStep,sarMaximum);
      
      if(handle_sar == INVALID_HANDLE)
      {
      Print("Error in loading of Color Parabolic. LastError = ",GetLastError());
      return(-1);
      } 
   
   ChartIndicatorAdd(ChartID(),0,handle_sar); 
   ArraySetAsSeries(sarBuy    ,true);  
   ArraySetAsSeries(sarSell   ,true);
   ArraySetAsSeries(sarUpTrend,true);  
   ArraySetAsSeries(sarDnTrend,true);
   }  
   
   
   if(rsiMode > 0)
   {
   handle_rsi = iCustom(Symbol(),rsiTimeFrame,"UltraRSI",rsiPeriod,rsiApplied_price,rsiW_Method,rsiStartLength,rsiWPhase,rsiStep,rsiStepsTotal,rsiSmoothMethod,rsiSmoothLength,rsiSmoothPhase,rsiUpLevel,rsiDnLevel,Blue,Blue,2,1);
      
      if(handle_sar == INVALID_HANDLE)
      {
      Print("Error in loading of UltraRSI. LastError = ",GetLastError());
      return(-1);
      } 
   
   ChartIndicatorAdd(ChartID(),1,handle_rsi); 
   ArraySetAsSeries(rsiBulls,true);  
   ArraySetAsSeries(rsiBears,true);
   }  
   
   
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---
   IndicatorRelease(handle_pcs);
   IndicatorRelease(handle_sar);
   IndicatorRelease(handle_rsi);
   
   ArrayFree(upSignal); 
   ArrayFree(dnSignal);
   ArrayFree(upEntry); 
   ArrayFree(dnEntry);
   ArrayFree(sarBuy); 
   ArrayFree(sarSell);
   ArrayFree(sarUpTrend); 
   ArrayFree(sarDnTrend);
   ArrayFree(rsiBulls); 
   ArrayFree(rsiBears);
      
   Comment("");   
}
//---

bool TimeCondition()
{
   bool tresult = false;
   int    Start_h, MonStart_h, MonStart_min, FriEnd_h, FriEnd_min;
   double MonStart, FriEnd;
   datetime MonSessionStart, FriSessionEnd;
   
   if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
   {
      if(StartHour == 24) Start_h = 0; else Start_h = StartHour; 
      
      datetime SessionStart = StringToTime((string)Start_h+":"+(string)StartMinute);
      double Start = Start_h + StartMinute/60.0;
      datetime SessionEnd   = StringToTime((string)EndHour+":"+(string)EndMinute);
      double End   = EndHour + EndMinute/60.0; 
   
      if(DayOfWeek() != 1 && DayOfWeek() != 5)
      {    
         if (Start < End) tresult = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);      
         else
         if (Start > End)
         tresult = (TimeCurrent() >= SessionStart && TimeCurrent() < StringToTime((string)23+":"+(string)59))
                ||(TimeCurrent() >= StringToTime((string)0+":"+(string)0) && TimeCurrent() < SessionEnd);
      }
      else
      if(DayOfWeek() == 1)
      {    
      if(MonStartHour < 0 || MonStartMinute < 0) {MonStart_h = StartHour; MonStart_min = StartMinute;}
      else {MonStart_h = MonStartHour; MonStart_min = MonStartMinute;} 
        
         if(MonStart_h > 0 || MonStart_min > 0) 
         {
         MonSessionStart = StringToTime((string)MonStart_h +":"+(string)MonStart_min);
         MonStart = MonStart_h + MonStart_min/60.0;
         }
         else
         {
         MonSessionStart = StringToTime((string)0+":"+(string)0); //SessionStart;
         MonStart = 0;//Start;
         }
            
         if (Start < End)
         { 
            if (MonStart != 0) tresult = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
            else tresult = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
         }
         else
         if (Start > End)
         {
         tresult = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd) 
                  ||(TimeCurrent() >= SessionStart && TimeCurrent() < StringToTime((string)23+":"+(string)59));
         
         
         }
      }
      else
      if(DayOfWeek() == 5)
      {
      if(FriEndHour < 0 || FriEndMinute < 0) {FriEnd_h = EndHour; FriEnd_min = EndMinute;}   
      else {FriEnd_h = FriEndHour; FriEnd_min = FriEndMinute;}
          
         if(FriEnd_h > 0 || FriEnd_min > 0)
         {
         FriSessionEnd   = StringToTime((string)FriEnd_h +":"+(string)FriEnd_min);
         FriEnd   = FriEnd_h + FriEnd_min/60.0; 
         }
         else
         {
         FriSessionEnd   = SessionEnd;
         FriEnd = End; 
         }
            
         if (Start < End)
         {
         if (FriEnd != End) tresult = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
         else
         tresult = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;  
         }
         else
         if (Start > End)
         tresult = (TimeCurrent() >= StringToTime((string)0+":"+(string)0) && TimeCurrent() < SessionEnd)
                ||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
      }  
   }
   
   return(tresult);
}   

// ---- Money Management
bool MoneyManagement (int mode,double maxloss,double volume,double& lots[])
{
   int NumOrders; 
   double vol, maxLots;
   
   double freeMargin = AccountInfoDouble(ACCOUNT_FREEMARGIN);
   int leverage = (int)AccountInfoInteger(ACCOUNT_LEVERAGE);
   
   if(mode == 1 && RiskFactor > 0) vol = NormalizeDouble(freeMargin*0.01*RiskFactor*leverage/contract,2);  
   else
   if(mode == 2 && RiskFactor > 0 && maxloss > 0) vol = NormalizeDouble(freeMargin*10*RiskFactor/maxloss*leverage/contract,2);   
   else
   vol = Lots;
      
   vol = NormalizeDouble(vol/lot_step,0)*lot_step;
     
 
   if(MaxLots == 0) maxLots = lot_max; else maxLots = MaxLots;
   if(vol > lot_max) vol = lot_max;  
   if(vol < lot_min) vol = lot_min;
  
   if(vol <= maxLots ) 
   {
   NumOrders = 1;
   ArrayResize(aLots,NumOrders);
   lots[NumOrders-1] = vol;
   if(vol < lot_min) aLots[NumOrders-1] = lot_min;
   }  
   else
   {
   NumOrders = (int)MathFloor(vol/maxLots); 
      
   ArrayResize(aLots,NumOrders);
   
      double SumVol = 0;
      for (int i=0;i<NumOrders-1;i++)
      {
      lots[i] = NormalizeDouble(MathCeil(vol/lot_step/NumOrders),0)*lot_step;
      if(lots[i] > maxLots) lots[i] = maxLots; 
      SumVol += lots[i];
      }
      
   lots[NumOrders-1] = vol - SumVol; 
   if(lots[NumOrders-1] > maxLots) lots[NumOrders-1] = maxLots;
   }         
//---
   if (NumOrders > 0) return(true); else return(false);
}   

// ---- Scan Trades
int ScanTrades(int mode,int& buy,int& sell,double& volume)
{   
   int total = PositionsTotal();
   buy = 0; sell = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol = PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC) == Magic) 
      {
      if((mode == 0 || mode == 1) && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) buy++; 
      if((mode == 0 || mode == 2) && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) sell++;
      }
   }
   
   if(buy + sell > 0) volume = PositionGetDouble(POSITION_VOLUME);
    
   return(buy + sell);
}  


// ---- Open Sell Orders
void OpenSell(double lot)
{
   string symbol    =_Symbol;                    
   double volume    = lot; 
   double price     = tick.bid; 
   double deviation = Slippage;         
   string comment   = Expert_Name+" SELL"; 
   double sl, tp;
   
   if(StopLossMode == 1)
   {
      if(StopLoss > 0 ) 
      {
      sl = NormalizeDouble(price + StopLoss*_point,_Digits);
      sl = MathMax(sl,price + minstop*_point); 
      }
      else sl = 0;
   }
   else sl = 0;
            
   if(TakeProfit == 0) tp = 0;
   else 
   {
   tp = NormalizeDouble(price - TakeProfit*_point,_Digits);
   tp = MathMin(tp,price - minstop*_point);
   }   
   
   if(!trade.Sell(volume,symbol,price,sl,tp,comment))
   {
   Print("OpenSell() failed. Return code=",trade.ResultRetcode(),
         ". Code description: ",trade.ResultRetcodeDescription());
   }
   else
   {
   Print("OpenSell() executed successfully. Return code=",trade.ResultRetcode(),
         " (",trade.ResultRetcodeDescription(),")");
   }
}

void OpenBuy(double lot)
{
//--- 
   string symbol    =_Symbol;                    
   double volume    = lot; 
   double price     = tick.ask; 
   double deviation = Slippage;         
   string comment   = Expert_Name+" BUY"; 
   double sl, tp;
   
   if(StopLossMode == 1)
   {
      if(StopLoss > 0 ) 
      {
      sl = NormalizeDouble(price - StopLoss*_point,_Digits);
      sl = MathMin(sl,price - minstop*_point); 
      }
      else sl = 0;
   }
   else sl = 0;
         
   if(TakeProfit == 0) tp = 0;
   else 
   {
   tp = NormalizeDouble(price + TakeProfit*_point,_Digits);
   tp = MathMax(tp,price + minstop*_point);
   }   
  
   if(!trade.Buy(volume,symbol,price,sl,tp,comment))
   {
   Print("OpenBuy() failed. Return code=",trade.ResultRetcode(),
         ". Code description: ",trade.ResultRetcodeDescription());
   }
   else
   {
   Print("OpenBuy() executed successfully. Return code=",trade.ResultRetcode(),
         " (",trade.ResultRetcodeDescription(),")");
   }
}

void CloseOrder(int mode)
{
   int total = PositionsTotal();
         
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol = PositionGetSymbol(cnt);
      
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC) == Magic) 
      {
         if((mode == 0 || mode == 1) && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
         {
            if(!trade.PositionClose(sSymbol))
            {
            Print("BuyPositionClose() failed. Return code=",trade.ResultRetcode(),
                  ". Code description: ",trade.ResultRetcodeDescription());
            }
            else
            {
            Print("BuyPositionClose() executed successfully. Return code=",trade.ResultRetcode(),
                  " (",trade.ResultRetcodeDescription(),")");
            }
         }
   
         if((mode == 0 || mode == 2) && PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
         {
            if(!trade.PositionClose(sSymbol))
            {
            Print("SellPositionClose() failed. Return code=",trade.ResultRetcode(),
                  ". Code description: ",trade.ResultRetcodeDescription());
            }
            else
            {
            Print("SellPositionClose() executed successfully. Return code=",trade.ResultRetcode(),
                  " (",trade.ResultRetcodeDescription(),")");
            }
         }
      }
   }
}




void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   double pips = TotalProfit(1);
   double usd  = TotalProfit(0), volume=0;
   int sell = 0, buy = 0;
   double upSig, dnSig, upEnt, dnEnt;
   
   
   ScanTrades(0,buy,sell,volume);
      
   sComment = sp;
   sComment = sComment+"Expert Name : "+Expert_Name+NL;
   sComment = sComment+"MM system=" + (string)MM_Mode + NL;
   sComment = sComment+sp;
   sComment = sComment+"Time: Current= "+TimeToString(TimeCurrent()) + NL;
   sComment = sComment+"Position: BUY="+(string)buy +" SELL= "+(string)sell+" Volume=" + DoubleToString(volume,2) + NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToString(pips,1) + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToString(usd,2)  + NL;

   sComment = sComment+sp;
   
   if(DebugMode > 0)
   {
   sComment = sComment+"Time[0]= " + TimeToString(Time[0]) + "Time[1]= " + TimeToString(Time[1]) + " prevTime=" + TimeToString(prevTime)+ " Trades=" + (string)Trades + " Signal=" + (string)Signal + NL;
   
      if(pcsMode > 0)
      {
      if(upSignal[0] == EMPTY_VALUE) upSig = 0; else upSig = upSignal[0];
      if(dnSignal[0] == EMPTY_VALUE) dnSig = 0; else dnSig = dnSignal[0];
      if(upEntry[0]  == EMPTY_VALUE) upEnt = 0; else upEnt = upEntry[0];
      if(dnEntry[0]  == EMPTY_VALUE) dnEnt = 0; else dnEnt = dnEntry[0];
      
      sComment = sComment+"upSignal= " + DoubleToString(upSig,_Digits) + " dnSignal= " + DoubleToString(dnSig,_Digits) + " upEntry= " + DoubleToString(upEnt,_Digits) + " dnEntry= " + DoubleToString(dnEnt,_Digits) + NL; 
      
      }
      
      if(sarMode > 0)
      {
      sComment = sComment+"sarBuy= " + DoubleToString(sarBuy[0],_Digits) + " sarSell= " + DoubleToString(sarSell[0],_Digits) + " sarUpTrend= " + DoubleToString(sarUpTrend[0],_Digits) + " sarDnTrend= " + DoubleToString(sarDnTrend[0],_Digits) + NL; 
      }
   
      if(rsiMode > 0) 
      {
      sComment = sComment+"rsiBulls= " + DoubleToString(rsiBulls[0],_Digits) + " rsiBulls= " + DoubleToString(rsiBears[0],_Digits) + NL; 
       
      }
   
   sComment = sComment+"Day="+ (string) DayOfWeek() + "  TimeCond=" + (string)timecond + " pcsMode=" + (string)pcsMode + " sarMode=" + (string)sarMode + " rsiMode=" + (string)rsiMode + NL;
   }
   
   Comment(sComment);
}




double TotalProfit(int mode)
{
   int total = PositionsTotal();
   double profit = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol=PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC) == Magic) 
      {
      double open  = PositionGetDouble(POSITION_PRICE_OPEN);
      double close = PositionGetDouble(POSITION_PRICE_CURRENT);
      
         if(mode == 1)
         {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) profit = (close - open)/_point;
         else
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) profit = (open - close)/_point;
         }
         else
         profit = PositionGetDouble(POSITION_PROFIT) + PositionGetDouble(POSITION_SWAP) + PositionGetDouble(POSITION_COMMISSION);
      }
   }
    
   return(profit);
}
//---- 
int pcSignal(int mode,int bar)
{   
   int result1 = 0;
     
   if(CopyBuffer(handle_pcs,0,bar,3,upSignal) <= 0) return(0);  
   if(CopyBuffer(handle_pcs,1,bar,3,dnSignal) <= 0) return(0);
   if(CopyBuffer(handle_pcs,2,bar,3,upEntry ) <= 0) return(0);
   if(CopyBuffer(handle_pcs,3,bar,3,dnEntry ) <= 0) return(0);
     
      
   if(mode == 1)
   { 
   if((upSignal[0] > 0 && upSignal[0]!= EMPTY_VALUE)||(pcsUseReEntry && upEntry[0] > 0 && upEntry[0] != EMPTY_VALUE)) result1 = mode; 
   if((dnSignal[0] > 0 && dnSignal[0]!= EMPTY_VALUE)||(pcsUseReEntry && dnEntry[0] > 0 && dnEntry[0] != EMPTY_VALUE)) result1 =-mode; 
   }
   
   
   return(result1);  
}
//----
int sarSignal(int mode,int bar)
{   
   int result2 = 0;
     
   
   if(CopyBuffer(handle_sar,0,bar,2,sarDnTrend) <= 0) return(0);  
   if(CopyBuffer(handle_sar,1,bar,2,sarUpTrend) <= 0) return(0);   
   if(CopyBuffer(handle_sar,2,bar,2,sarSell   ) <= 0) return(0);   
   if(CopyBuffer(handle_sar,3,bar,2,sarBuy    ) <= 0) return(0);   
   
//----      
   if(mode == 1)
   { 
   if(sarBuy[0]  > 0 || sarUpTrend[0] > 0) result2 = mode; 
   if(sarSell[0] > 0 || sarDnTrend[0] > 0) result2 =-mode; 
   }
   
   
   return(result2);  
}
//----
int rsiSignal(int mode,int bar)
{   
   int result3 = 0;
     
   if(CopyBuffer(handle_rsi,0,bar,2,rsiBulls) <= 0) return(0);   
   if(CopyBuffer(handle_rsi,1,bar,2,rsiBears) <= 0) return(0);   
      

   if(mode == 1)
   { 
   if(rsiBulls[0] > rsiBears[0]) result3 = mode; 
   if(rsiBears[0] > rsiBulls[0]) result3 =-mode; 
   }
   
   
   return(result3);  
}

//----
int TradeSignal()
{   
   int signal = 0, pcs = 0, sar = 0, rsi = 0;
   
   if(pcsMode > 0)
   pcs = pcSignal(pcsMode,pcsShift);
   
   if(sarMode > 0)
   sar = sarSignal(sarMode,sarShift);
     
   if(rsiMode > 0)
   rsi = rsiSignal(rsiMode,rsiShift);
   
   
   if(pcs != 0 || sar != 0 || rsi != 0)
   {
   if(pcs == pcsMode && sar == sarMode && rsi == rsiMode) signal = 1; 
   if(pcs ==-pcsMode && sar ==-sarMode && rsi ==-rsiMode) signal =-1; 
   }

   return(signal);
}

void TrailStop()
{
   double gain, buyStop, sellStop;
   int    total = PositionsTotal(); 
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol = PositionGetSymbol(cnt);
   if(!PositionSelect(sSymbol) || sSymbol != _Symbol || PositionGetInteger(POSITION_MAGIC) != Magic) continue; 
   
   int mode  = (int)PositionGetInteger(POSITION_TYPE);    
   
   double op = PositionGetDouble(POSITION_PRICE_OPEN);
   double sl = PositionGetDouble(POSITION_SL);
   double tp = NormalizeDouble(PositionGetDouble(POSITION_TP),_Digits);
        
      if(mode == POSITION_TYPE_BUY)
      {
		gain = 0;  buyStop = 0;
		double bid = tick.bid; //SymbolInfoDouble(Symbol(),SYMBOL_BID);	   
		   if(BreakEven > 0 && NormalizeDouble(sl - op,_Digits) < NormalizeDouble(ProfitLock*_point,_Digits))
			{
			gain  = NormalizeDouble((bid - op)/_point,_Digits);
			if(gain >= BreakEven) buyStop = NormalizeDouble(op + ProfitLock*_point,_Digits);
			}
			else
			if(TrailingStop > 0) buyStop = NormalizeDouble(bid - TrailingStop*_point,_Digits);
			else buyStop = 0; 			   
			
			if(buyStop <= 0) continue; 
			   
			if(bid - buyStop < minstop*_point) buyStop = NormalizeDouble(bid - minstop*_point,_Digits);   
              
			if(NormalizeDouble(op,_Digits) <= buyStop) 
         {   
			   if(buyStop > NormalizeDouble(sl,_Digits) || sl == 0) 
			   {
			      if(!trade.PositionModify(sSymbol,buyStop,tp))
               {
               Print("BuyPositionModify() failed. Return code=",trade.ResultRetcode(),
                     ". Code description: ",trade.ResultRetcodeDescription());
               Print("Buy: sl=",sl," tp=",tp);
               }
               else
               {
               Print("BuyPositionModify() executed successfully. Return code=",trade.ResultRetcode(),
                     " (",trade.ResultRetcodeDescription(),")");
               }
            }
         }
      }            
// - SELL           
      if(mode == POSITION_TYPE_SELL)
      {
		gain = 0;  sellStop = 0;
		double ask = tick.ask; //SymbolInfoDouble(Symbol(),SYMBOL_ASK);		   
		   if(BreakEven > 0 && NormalizeDouble(op - sl,_Digits) < NormalizeDouble(ProfitLock*_point,_Digits))
			{
			gain  = NormalizeDouble((op - ask)/_point,_Digits);
			if(gain >= BreakEven) sellStop = NormalizeDouble(op - ProfitLock*_point,_Digits);
			}
			else
			if(TrailingStop > 0) sellStop = NormalizeDouble(ask + TrailingStop*_point,_Digits);
			else sellStop = 0; 			   
			
			if(sellStop <= 0) continue; 
			   
			if(sellStop - ask < minstop*_point) sellStop = NormalizeDouble(ask + minstop*_point,_Digits);   
              
			if(NormalizeDouble(op,_Digits) >= sellStop) 
         {   
			   if(sellStop < NormalizeDouble(sl,_Digits) && sellStop > 0 || sl == 0) 
			   {
			      if(!trade.PositionModify(sSymbol,sellStop,tp))
               {
               Print("SellPositionModify() failed. Return code=",trade.ResultRetcode(),
                     ". Code description: ",trade.ResultRetcodeDescription());
               Print("Sell: sl=",sl," tp=",tp);
               }
               else
               {
               Print("SellPositionModify() executed successfully. Return code=",trade.ResultRetcode(),
                     " (",trade.ResultRetcodeDescription(),")");
               }
            }
         }
      }            
   }     
}

int DayOfWeek()
{
   MqlDateTime tm;
   TimeCurrent(tm);
   return(tm.day_of_week);
}

bool isNewBar(int tf)
{
   static datetime _pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= _pTime)
      {
      res = true;
      _pTime = iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

datetime iTime(string symbol,int tf,int index)
{
   if(index < 0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   datetime Arr[];
   if(CopyTime(symbol, timeframe, index, 1, Arr)>0)
        return(Arr[0]);
   else return(-1);
}

ENUM_TIMEFRAMES TFMigrate(int tf)
{
   switch(tf)
   {
   case 0    : return(PERIOD_CURRENT);
   case 1    : return(PERIOD_M1);
   case 5    : return(PERIOD_M5);
   case 15   : return(PERIOD_M15);
   case 30   : return(PERIOD_M30);
   case 60   : return(PERIOD_H1);
   case 240  : return(PERIOD_H4);
   case 1440 : return(PERIOD_D1);
   case 10080: return(PERIOD_W1);
   case 43200: return(PERIOD_MN1);
      
   case 2    : return(PERIOD_M2);
   case 3    : return(PERIOD_M3);
   case 4    : return(PERIOD_M4);      
   case 6    : return(PERIOD_M6);
   case 10   : return(PERIOD_M10);
   case 12   : return(PERIOD_M12);
   case 16385: return(PERIOD_H1);
   case 16386: return(PERIOD_H2);
   case 16387: return(PERIOD_H3);
   case 16388: return(PERIOD_H4);
   case 16390: return(PERIOD_H6);
   case 16392: return(PERIOD_H8);
   case 16396: return(PERIOD_H12);
   case 16408: return(PERIOD_D1);
   case 32769: return(PERIOD_W1);
   case 49153: return(PERIOD_MN1);      
   default: return(PERIOD_CURRENT);
   }
} 
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   
   double volume;
//---
   if(!SymbolInfoTick(_Symbol, tick)) return;
   
   
   if(pcsMode > 0) CopyTime (_Symbol,pcsTimeFrame,0,2,Time);
   if(sarMode > 0 && pcsMode == 0) CopyTime (_Symbol,sarTimeFrame,0,2,Time);
   if(rsiMode > 0 && pcsMode == 0 && sarMode == 0) CopyTime (_Symbol,rsiTimeFrame,0,2,Time);
      
   int buy, sell;
   
   Trades = ScanTrades(0,buy,sell, volume);  
   
   timecond = false;
   
   timecond = TimeCondition();
   
   Signal = 0;
   
   if(isNewBar(MainTimeFrame)) Signal = TradeSignal(); 
   
   if(CommentMode > 0) ChartComment();
   
       
   if(Trades > 0)
   {
      if(ExitMode == 1)
      {
      if(buy  > 0 && Signal < 0) {CloseOrder(1); Print("close BUY 1" );}
      if(sell > 0 && Signal > 0) {CloseOrder(2); Print("close SELL 1");}     
      }
   
      if(BreakEven > 0 || TrailingStop > 0) TrailStop();     
      
      if (CloseTimeMode > 0) 
      {
      datetime TimeClose = StringToTime((string)CloseHour+":"+(string)CloseMinute); 
      if(FriCloseHour >= 0 && DayOfWeek() == 5 && FriCloseHour > StartHour) TimeClose = StringToTime((string)FriCloseHour+":"+(string)FriCloseMinute); 
      
      if(TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose + ProcessTime*60) CloseOrder(0); 
      }
   }

   if (Signal != 0 && Trades == 0  && timecond && Time[0] != prevTime)
   {
   MoneyManagement(MM_Mode,MaxLoss,volume,aLots); 
   
   int asize = ArraySize(aLots); 
    
      if(asize > 0)
      {   
         for(int i=0;i<asize;i++)
         {
            if(ReverseMode == 0)
            {
            if(Signal > 0) OpenBuy (aLots[i]);
            if(Signal < 0) OpenSell(aLots[i]);
            }
            else
            {
            if(Signal > 0) OpenSell(aLots[i]);
            if(Signal < 0) OpenBuy (aLots[i]);
            }
         }   
      }
      
   prevTime = Time[0];
   }
}
//+------------------------------------------------------------------+
